/* SPDX-License-Identifier: GPL-2.0+ */
/*
 * Copyright (c) 2017 Tuomas Tynkkynen
 */

#ifndef __CONFIG_H
#define __CONFIG_H

#include <linux/sizes.h>

/* Physical memory map */

/* The DTB generated by QEMU is placed at start of RAM, stay away from there */
#define CONFIG_SYS_INIT_SP_ADDR		(CONFIG_SYS_SDRAM_BASE + SZ_2M)

#define CONFIG_SYS_BOOTM_LEN		SZ_64M

#define FDT_ADDR			CONFIG_SYS_FDT_ADDR
#define KERNEL_ADDR_R			CONFIG_SYS_LOAD_ADDR
#define RAMDISK_ADDR_R			CONFIG_SYS_RAMDISK_ADDR_R
#define SCRIPT_ADDR			CONFIG_SYS_SCRIPT_ADDR
#define PXEFILE_ADDR_R			CONFIG_SYS_PXEFILE_ADDR_R

/* For timer, QEMU emulates an ARMv7/ARMv8 architected timer */

/* Environment options */

#ifdef CONFIG_DISTRO_DEFAULTS

#if CONFIG_IS_ENABLED(CMD_USB)
# define BOOT_TARGET_USB(func) func(USB, usb, 0)
#else
# define BOOT_TARGET_USB(func)
#endif

#if CONFIG_IS_ENABLED(CMD_SCSI)
# define BOOT_TARGET_SCSI(func) func(SCSI, scsi, 0)
#else
# define BOOT_TARGET_SCSI(func)
#endif

#if CONFIG_IS_ENABLED(CMD_VIRTIO)
# define BOOT_TARGET_VIRTIO(func) func(VIRTIO, virtio, 0)
#else
# define BOOT_TARGET_VIRTIO(func)
#endif

#if CONFIG_IS_ENABLED(CMD_DHCP)
# define BOOT_TARGET_DHCP(func) func(DHCP, dhcp, na)
#else
# define BOOT_TARGET_DHCP(func)
#endif

#define BOOT_TARGET_DEVICES(func) \
	BOOT_TARGET_USB(func) \
	BOOT_TARGET_SCSI(func) \
	BOOT_TARGET_VIRTIO(func) \
	BOOT_TARGET_DHCP(func)

#include <config_distro_bootcmd.h>
#else
#define BOOTENV
#endif

#define CONFIG_EXTRA_ENV_SETTINGS \
	"fdt_high=0xffffffff\0" \
	"initrd_high=0xffffffff\0" \
	"fdt_addr=" __stringify(FDT_ADDR) "\0" \
	"scriptaddr=" __stringify(SCRIPT_ADDR) "\0" \
	"pxefile_addr_r=" __stringify(PXEFILE_ADDR_R) "\0" \
	"kernel_addr_r=" __stringify(KERNEL_ADDR_R) "\0" \
	"ramdisk_addr_r=" __stringify(RAMDISK_ADDR_R) "\0" \
	BOOTENV

#define CONFIG_ENV_FLAGS_LIST_STATIC "fdtaddr:xo"

#define CONFIG_SYS_CBSIZE 512

#define CONFIG_SYS_MONITOR_BASE		CONFIG_SYS_TEXT_BASE
#define CONFIG_SYS_MAX_FLASH_BANKS_DETECT	2
#define CONFIG_SYS_MAX_FLASH_SECT	256 /* Sector: 256K, Bank: 64M */
#define CONFIG_CFI_FLASH_USE_WEAK_ACCESSORS

#endif /* __CONFIG_H */
